ON_Light Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_light.h>`

Inheritance diagram for ON_Light:

## Public Member Functions

| ON_Light ()
| ~ON_Light ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
ON_UUID | ModelObjectId () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
void | Default ()
ON_BOOL32 | Enable (ON_BOOL32=true)
ON_BOOL32 | IsEnabled () const
void | SetStyle (ON::light_style)
ON::light_style | Style () const
const ON_BOOL32 | IsPointLight () const
const ON_BOOL32 | IsDirectionalLight () const
const ON_BOOL32 | IsSpotLight () const
const ON_BOOL32 | IsLinearLight () const
const ON_BOOL32 | IsRectangularLight () const
ON::coordinate_system | CoordinateSystem () const
ON_BOOL32 | GetLightXform (const ON_Viewport &vp, ON::coordinate_system dest_cs, ON_Xform &xform) const
void | SetLocation (const ON_3dPoint &)
void | SetDirection (const ON_3dVector &)
ON_3dPoint | Location () const
ON_3dVector | Direction () const
ON_3dVector | PerpindicularDirection () const
double | Intensity () const
void | SetIntensity (double)
double | PowerWatts () const
double | PowerLumens () const
double | PowerCandela () const
void | SetPowerWatts (double)
void | SetPowerLumens (double)
void | SetPowerCandela (double)
void | SetAmbient (ON_Color)
void | SetDiffuse (ON_Color)
void | SetSpecular (ON_Color)
ON_Color | Ambient () const
ON_Color | Diffuse () const
ON_Color | Specular () const
void | SetAttenuation (double, double, double)
void | SetAttenuation (const ON_3dVector &)
ON_3dVector | Attenuation () const
double | Attenuation (double) const
void | SetSpotAngleDegrees (double)
double | SpotAngleDegrees () const
void | SetSpotAngleRadians (double)
double | SpotAngleRadians () const
void | SetSpotExponent (double)
double | SpotExponent () const
void | SetHotSpot (double)
double | HotSpot () const
bool | GetSpotLightRadii (double *inner_radius, double *outer_radius) const
void | SetLength (const ON_3dVector &)
ON_3dVector | Length () const
void | SetWidth (const ON_3dVector &)
ON_3dVector | Width () const
void | SetShadowIntensity (double)
double | ShadowIntensity () const
void | SetLightIndex (int)
int | LightIndex () const
void | SetLightName (const char *)
void | SetLightName (const wchar_t *)
const ON_wString & | LightName () const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Public Attributes

int | m_light_index
ON_UUID | m_light_id
ON_wString | m_light_name
ON_BOOL32 | m_bOn
ON::light_style | m_style
ON_Color | m_ambient
ON_Color | m_diffuse
ON_Color | m_specular
ON_3dVector | m_direction
ON_3dPoint | m_location
ON_3dVector | m_length
ON_3dVector | m_width
double | m_intensity
double | m_watts
double | m_spot_angle
double | m_spot_exponent
double | m_hotspot
ON_3dVector | m_attenuation
double | m_shadow_intensity

## Detailed Description

Definition at line 20 of file opennurbs_light.h.

## Constructor & Destructor Documentation

## ON_Light()

ON_Light::ON_Light | ( |  | ) |

## ~ON_Light()

ON_Light::~ON_Light | ( |  | ) |

## Member Function Documentation

## Ambient()

ON_Color ON_Light::Ambient | ( |  | ) | const

## Attenuation() [1/2]

ON_3dVector ON_Light::Attenuation | ( |  | ) | const

## Attenuation() [2/2]

double ON_Light::Attenuation | ( | double |  | ) | const

## CoordinateSystem()

ON::coordinate_system ON_Light::CoordinateSystem | ( |  | ) | const

## Default()

void ON_Light::Default | ( |  | ) |

## Diffuse()

ON_Color ON_Light::Diffuse | ( |  | ) | const

## Dimension()

int ON_Light::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Direction()

ON_3dVector ON_Light::Direction | ( |  | ) | const

## Dump()

void ON_Light::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Enable()

ON_BOOL32 ON_Light::Enable | ( | ON_BOOL32 | = `true` | ) |

## GetBBox()

ON_BOOL32 ON_Light::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetLightXform()

ON_BOOL32 ON_Light::GetLightXform | ( | const ON_Viewport & | vp,
|  | ON::coordinate_system | dest_cs,
|  | ON_Xform & | xform
| ) |  | const

## GetSpotLightRadii()

bool ON_Light::GetSpotLightRadii | ( | double * | inner_radius,
|  | double * | outer_radius
| ) |  | const

## HotSpot()

double ON_Light::HotSpot | ( |  | ) | const

## Intensity()

double ON_Light::Intensity | ( |  | ) | const

## IsDirectionalLight()

const ON_BOOL32 ON_Light::IsDirectionalLight | ( |  | ) | const

## IsEnabled()

ON_BOOL32 ON_Light::IsEnabled | ( |  | ) | const

## IsLinearLight()

const ON_BOOL32 ON_Light::IsLinearLight | ( |  | ) | const

## IsPointLight()

const ON_BOOL32 ON_Light::IsPointLight | ( |  | ) | const

## IsRectangularLight()

const ON_BOOL32 ON_Light::IsRectangularLight | ( |  | ) | const

## IsSpotLight()

const ON_BOOL32 ON_Light::IsSpotLight | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Light::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Length()

ON_3dVector ON_Light::Length | ( |  | ) | const

## LightIndex()

int ON_Light::LightIndex | ( |  | ) | const

## LightName()

const ON_wString& ON_Light::LightName | ( |  | ) | const

## Location()

ON_3dPoint ON_Light::Location | ( |  | ) | const

## ModelObjectId()

ON_UUID ON_Light::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## ObjectType()

ON::object_type ON_Light::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## PerpindicularDirection()

ON_3dVector ON_Light::PerpindicularDirection | ( |  | ) | const

## PowerCandela()

double ON_Light::PowerCandela | ( |  | ) | const

## PowerLumens()

double ON_Light::PowerLumens | ( |  | ) | const

## PowerWatts()

double ON_Light::PowerWatts | ( |  | ) | const

## Read()

ON_BOOL32 ON_Light::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## SetAmbient()

void ON_Light::SetAmbient | ( | ON_Color |  | ) |

## SetAttenuation() [1/2]

void ON_Light::SetAttenuation | ( | double | ,
|  | double | ,
|  | double |
| ) |  |

## SetAttenuation() [2/2]

void ON_Light::SetAttenuation | ( | const ON_3dVector & |  | ) |

## SetDiffuse()

void ON_Light::SetDiffuse | ( | ON_Color |  | ) |

## SetDirection()

void ON_Light::SetDirection | ( | const ON_3dVector & |  | ) |

## SetHotSpot()

void ON_Light::SetHotSpot | ( | double |  | ) |

## SetIntensity()

void ON_Light::SetIntensity | ( | double |  | ) |

## SetLength()

void ON_Light::SetLength | ( | const ON_3dVector & |  | ) |

## SetLightIndex()

void ON_Light::SetLightIndex | ( | int |  | ) |

## SetLightName() [1/2]

void ON_Light::SetLightName | ( | const char * |  | ) |

## SetLightName() [2/2]

void ON_Light::SetLightName | ( | const wchar_t * |  | ) |

## SetLocation()

void ON_Light::SetLocation | ( | const ON_3dPoint & |  | ) |

## SetPowerCandela()

void ON_Light::SetPowerCandela | ( | double |  | ) |

## SetPowerLumens()

void ON_Light::SetPowerLumens | ( | double |  | ) |

## SetPowerWatts()

void ON_Light::SetPowerWatts | ( | double |  | ) |

## SetShadowIntensity()

void ON_Light::SetShadowIntensity | ( | double |  | ) |

## SetSpecular()

void ON_Light::SetSpecular | ( | ON_Color |  | ) |

## SetSpotAngleDegrees()

void ON_Light::SetSpotAngleDegrees | ( | double |  | ) |

## SetSpotAngleRadians()

void ON_Light::SetSpotAngleRadians | ( | double |  | ) |

## SetSpotExponent()

void ON_Light::SetSpotExponent | ( | double |  | ) |

## SetStyle()

void ON_Light::SetStyle | ( | ON::light_style |  | ) |

## SetWidth()

void ON_Light::SetWidth | ( | const ON_3dVector & |  | ) |

## ShadowIntensity()

double ON_Light::ShadowIntensity | ( |  | ) | const

## Specular()

ON_Color ON_Light::Specular | ( |  | ) | const

## SpotAngleDegrees()

double ON_Light::SpotAngleDegrees | ( |  | ) | const

## SpotAngleRadians()

double ON_Light::SpotAngleRadians | ( |  | ) | const

## SpotExponent()

double ON_Light::SpotExponent | ( |  | ) | const

## Style()

ON::light_style ON_Light::Style | ( |  | ) | const

## Transform()

ON_BOOL32 ON_Light::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Width()

ON_3dVector ON_Light::Width | ( |  | ) | const

## Write()

ON_BOOL32 ON_Light::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_ambient

ON_Color ON_Light::m_ambient

Definition at line 268 of file opennurbs_light.h.

## m_attenuation

ON_3dVector ON_Light::m_attenuation

Definition at line 298 of file opennurbs_light.h.

## m_bOn

ON_BOOL32 ON_Light::m_bOn

Definition at line 265 of file opennurbs_light.h.

## m_diffuse

ON_Color ON_Light::m_diffuse

Definition at line 269 of file opennurbs_light.h.

## m_direction

ON_3dVector ON_Light::m_direction

Definition at line 272 of file opennurbs_light.h.

## m_hotspot

double ON_Light::m_hotspot

Definition at line 295 of file opennurbs_light.h.

## m_intensity

double ON_Light::m_intensity

Definition at line 280 of file opennurbs_light.h.

## m_length

ON_3dVector ON_Light::m_length

Definition at line 274 of file opennurbs_light.h.

## m_light_id

ON_UUID ON_Light::m_light_id

Definition at line 262 of file opennurbs_light.h.

## m_light_index

int ON_Light::m_light_index

Definition at line 261 of file opennurbs_light.h.

## m_light_name

ON_wString ON_Light::m_light_name

Definition at line 263 of file opennurbs_light.h.

## m_location

ON_3dPoint ON_Light::m_location

Definition at line 273 of file opennurbs_light.h.

## m_shadow_intensity

double ON_Light::m_shadow_intensity

Definition at line 303 of file opennurbs_light.h.

## m_specular

ON_Color ON_Light::m_specular

Definition at line 270 of file opennurbs_light.h.

## m_spot_angle

double ON_Light::m_spot_angle

Definition at line 291 of file opennurbs_light.h.

## m_spot_exponent

double ON_Light::m_spot_exponent

Definition at line 292 of file opennurbs_light.h.

## m_style

ON::light_style ON_Light::m_style

Definition at line 266 of file opennurbs_light.h.

## m_watts

double ON_Light::m_watts

Definition at line 286 of file opennurbs_light.h.

## m_width

ON_3dVector ON_Light::m_width

Definition at line 276 of file opennurbs_light.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_light.h